Bug 95211 - scons TypeError: 'tuple' object is not callable
Summary: scons TypeError: 'tuple' object is not callable
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Mesa core (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Jose Fonseca
QA Contact: mesa-dev
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-04-30 01:28 UTC by Vinson Lee
Modified: 2016-05-27 04:09 UTC (History)
1 user (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Vinson Lee 2016-04-30 01:28:20 UTC
mesa: 750c38fad1f19e2403b4960674006c5f932075ad (master 11.3.0-devel)

$ scons
scons: Reading SConscript files ...
Checking for GCC ...  yes
Checking for Clang ...  no
scons: Found LLVM version 3.8.0
Checking for X11 (x11 xext xdamage xfixes glproto >= 1.4.13)... yes
Checking for XCB (x11-xcb xcb-glx >= 1.8.1 xcb-dri2 >= 1.8)... yes
Checking for XF86VIDMODE (xxf86vm)... yes
Checking for DRM (libdrm >= 2.4.38)... yes
Checking for UDEV (libudev >= 151)... yes
TypeError: 'tuple' object is not callable:
  File "mesa/SConstruct", line 143:
    duplicate = 0 # http://www.scons.org/doc/0.97/HTML/scons-user/x2261.html
  File "/usr/lib/scons/SCons/Script/SConscript.py", line 604:
    return method(*args, **kw)
  File "/usr/lib/scons/SCons/Script/SConscript.py", line 541:
    return _SConscript(self.fs, *files, **subst_kw)
  File "/usr/lib/scons/SCons/Script/SConscript.py", line 250:
    exec _file_ in call_stack[-1].globals
  File "mesa/src/SConscript", line 7:
    SConscript('util/SConscript')
  File "/usr/lib/scons/SCons/Script/SConscript.py", line 604:
    return method(*args, **kw)
  File "/usr/lib/scons/SCons/Script/SConscript.py", line 541:
    return _SConscript(self.fs, *files, **subst_kw)
  File "/usr/lib/scons/SCons/Script/SConscript.py", line 250:
    exec _file_ in call_stack[-1].globals
  File "mesa/src/util/SConscript", line 25:
    command = python_cmd + ' $SCRIPT > $TARGET'
  File "/usr/lib/scons/SCons/Environment.py", line 224:
    return self.method(*nargs, **kwargs)
  File "mesa/scons/custom.py", line 143:
    deps += script_src.get_implicit_deps(env, python_scanner, path)
  File "/usr/lib/scons/SCons/Node/__init__.py", line 941:
    path = path_func(scanner)

$ scons --version
SCons by Steven Knight et al.:
	script: v2.5.0.rel_2.5.0:3544:95d356f188a3[MODIFIED], 2016/04/09 14:38:50, by bdbaddog on ubuntu1404-32bit
	engine: v2.5.0.rel_2.5.0:3544:95d356f188a3[MODIFIED], 2016/04/09 14:38:50, by bdbaddog on ubuntu1404-32bit
	engine path: ['/usr/lib/scons/SCons']
Copyright (c) 2001 - 2016 The SCons Foundation
Comment 1 Jose Fonseca 2016-05-04 13:56:08 UTC
It looks like SCons changed some of its internals.

Most likely it won't be an easy fix.  I'm not sure when I'll be able to look into this.

My suggestion is to use SCons 2.4.x for now.
Comment 2 Vinson Lee 2016-05-27 04:09:42 UTC
commit 1b62b47f6fcaf5a825a5a909c91e802bffae3b1d
Author: Giuseppe Bilotta <giuseppe.bilotta@gmail.com>
Date:   Wed May 25 07:32:08 2016 -0600

    scons: support 2.5.0
    
    The get_implicit_deps changed in SCons 2.5, expecting a callable rather
    than a path as third argument. Detect the SCons versions and set the
    argument appropriately to support both 2.5 and earlier versions.
    
    This closes #95211.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=95211
    Signed-off-by: Giuseppe Bilotta <giuseppe.bilotta@gmail.com>
    Cc: mesa-stable@lists.freedesktop.org
    Acked-by: Emil Velikov <emil.velikov@collabora.com>
    Reviewed-by: Brian Paul <brianp@vmware.com>


bug/show.html.tmpl processed on Feb 26, 2017 at 07:39:00.
(provided by the Example extension).